<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Repository;

use Dedi\SyliusVoucherPlugin\Model\VoucherInterface;
use Doctrine\ORM\QueryBuilder;
use Sylius\Component\Channel\Model\ChannelInterface;
use Sylius\Component\Core\Model\CustomerInterface;
use Sylius\Component\Core\Model\OrderItemUnitInterface;
use Sylius\Component\Resource\Repository\RepositoryInterface;

interface VoucherRepositoryInterface extends RepositoryInterface
{
    public function createListQueryBuilder(): QueryBuilder;

    public function findOneEnabledByCodeAndChannel(string $code, ChannelInterface $channel): ?VoucherInterface;

    public function findOneByCode(string $code): ?VoucherInterface;

    public function findOneByOrderItemUnit(OrderItemUnitInterface $orderItemUnit): ?VoucherInterface;

    /**
     * @return VoucherInterface[]
     */
    public function findEnabled(): array;

    public function createAccountListQueryBuilder(CustomerInterface $customer): QueryBuilder;
}
